# Mightier Amp
Alternative app for controlling NUX Mighty amps series.

## Features
This app aims to cover all the functionality of the original app plus many enhancements:
- Ability to save presets locally on your mobile device and export them to share with others.
- Remote control using a MIDI controller or a HID device. Both USB and Bluetooth MIDI controllers are supported.
- Landscape mode.
- Improved Jam Tracks functionality. Select any audio file in your device, add events like loop points, preset changes and others at any point and play along.
- The app unlocks 8 secret amp models in Mighty Plug Pro and Mighty Space: Twin Rvb, Class A15, Vibro King, Budda, Brit Blues, Match D30, Brit 2000 and Uber HiGain
- Tempo/Beat Trainer
- Various other enhancements.

## Supported Amps

1.Mighty Plug / Mighty Air  
2.Mighty Plug Pro / Mighty Space  
3.Mighty Lite BT MKII  
4.Mighty 8 BT\*\*  
5.Mighty 20 BT \*\* / Mighty 40 BT \*\*
6.Mighty BT Lite / AirBorne Go\*\* / GUO AN\*\*  

\*\* These amps are not tested and might not work.  

## Helpful Resources
Check out the great video tutorial series created by Diego Zuccotti, where he walks through the features and functionality of the app, and the usage of the NUX amps in general.  
[Click here to watch!](https://www.youtube.com/@TutoJam)

Facebook groups for presets sharing and amps discussion:  
[Mighty Plug/Mighty Air](https://www.facebook.com/groups/nuxmightyplugairgroup/)  
[Mighty Plug Pro/Mighty Space](https://www.facebook.com/groups/mightyplugpro/)  

## Download

[<img src="https://play.google.com/intl/en_us/badges/images/generic/en-play-badge.png"
     alt="Get it on Google Play"
     height="80">](https://play.google.com/store/apps/details?id=com.tuntori.mightieramp)
[<img src="docs/ios_web_generic.png"
     alt="Get it on Google Play"
     height="82">](https://apps.apple.com/us/app/mightier-amp/id6447451371)
[<img src="https://fdroid.gitlab.io/artwork/badge/get-it-on.png"
     alt="Get it on F-Droid"
     height="80">](https://f-droid.org/packages/com.tuntori.mightieramp/)

## Donation
Mightier Amp is an open-source project that I am developing in my free time. If you find the app useful and would like to support its development, please consider making a donation. Your contribution will help me invest more time into the development of the app. Thank you for your support!

<a href='https://ko-fi.com/tuntori' target='_blank'><img height='35' style='border:0px;height:46px;' src='https://az743702.vo.msecnd.net/cdn/kofi3.png?v=0' border='0' alt='Buy Me a Coffee at ko-fi.com' />
&nbsp;&nbsp;[![paypal](https://www.paypalobjects.com/en_US/i/btn/btn_donateCC_LG.gif)](https://www.paypal.com/donate?hosted_button_id=FZWWAM4NUFRPC)  
